<?php
if ( ! class_exists( 'IPSocialWidget_Admin' )) {

    /**
     * Class for handling administrator page
     */
    class IPSocialWidget_Admin
    {
        /**
         * Show content admin home
         *
         * @return void
         */
        public function index()
        {
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2>
                    <?php echo IPSOCWIDGET_TITLE; ?>
                    <a class="add-new-h2" href="admin.php?page=wp-socwidget-add" title="Add New Widget">Add New</a>
                </h2>
                <div id="ip_messages"></div>
                
                <?php
                require_once( plugin_dir_path( __FILE__ ) . "list-table.php" );
                $paginArgs = array(
                    "per_page" => 20 
                );
                $listTable = new IPSocialWidget_ListTable();
                $listTable->prepare_items();
                $listTable->display();
                ?>
                
            </div>
        <?php
        }
        
        /**
         * Show content for insert widget sortcode
         *
         * @return void
         */
        public function popup()
        {
            $args = array(
                'orderby'     => 'post_date',
                'order'       => 'DESC', 
                'post_type'   => 'ipsocialwidget',
                'post_status' => array(
                    'timeline',
                    'author',
                    'email',
                    'sales',
                    'contact',
                    'profile',
                    'link',
                ),
                'posts_per_page' => -1,
                'paged'          => $page
            );
            $query   = new WP_Query;
            $widgets = $query->query( $args );
        ?>
            <div id="ipsw-shortcode-popup" style="display: none;">
                <div class="ipsw-popup-inner">
                    <p>Please choose one of the widgets that you want to insert.</p>
                    <?php
                    if ( ! empty( $widgets )) :
                    ?>
                        <table id="ipsw-widget-table">
                            <thead>
                                <tr>
                                    <th></th>
                                    <th><?php _e( 'Name' ); ?></th>
                                    <th><?php _e( 'Type' ); ?></th>
                                    <th><?php _e( 'Style' ); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                            <?php
                            foreach( $widgets as $widget ) :
                                $setting = new IPSocialWidget_Setting( $widget->ID );
                            ?>
                                <tr>
                                    <td>
                                        <input type="radio" id="widget_<?php echo $widget->ID; ?>" name="widget_id" value="<?php echo $widget->ID; ?>">
                                    </td>
                                    <td>
                                        <?php echo '<label for="widget_' . $widget->ID . '">' . $widget->post_title . '</label>'; ?>
                                    </td>
                                    <td>
                                        <?php
                                        $status = $widget->post_status;
                                        if ( $status == 'timeline' ) {
                                            $type = __( 'Social Timeline' );
                                        } elseif ( $status == 'author' ) {
                                            $type = __( 'Author' );
                                        } elseif ( $status == 'email' ) {
                                            $type = __( 'Email Block' );
                                        } elseif ( $status == 'sales' ) {
                                            $type = __( 'Sales Block' );
                                        } elseif ( $status == 'contact' ) {
                                            $type = __( 'Contact Detail' );
                                        } elseif ( $status == 'profile' ) {
                                            $type = __( 'Social Profile' );
                                        } elseif ( $status == 'link' ) {
                                            $type = __( 'Social Link' );
                                        }
                                        echo $type;
                                        echo '<input type="hidden" class="ipsw-type" value="' . $widget->post_status . '" name="ipsw_type">';
                                        ?>
                                    </td>
                                    <td>
                                        <?php
                                        echo $setting->getSetting( 'style' );
                                        ?>
                                    </td>
                                </tr>
                            <?php
                            endforeach;
                            ?>
                            </tbody>
                        </table>
                        <div class="buttons isc-clear">
                            <input type="submit" class="button button-primary button-large ipsw-shortcode-insert" name="ipsw_shortcode_insert" value="<?php _e( 'Insert' ); ?>" />
                        </div>
                    <?php
                    else :
                    ?>
                    
                        <p class="info">Widgets are not yet available, please <a href="?page=wp-socwidget-add">create it</a> first.</p>
                    
                    <?php
                    endif;
                    ?>
                </div>
            </div>
        
        <?php
        }
        
        /**
         * Show content admin site popup
         *
         * @return void
         */
        public function adminPopup()
        {
            $submit  = false;
            $success = true;
            if ( isset( $_POST['ipsw_set_popup'] )) {
                $submit  = true;
                $popupid = absint( $_POST['widget'] );
                $width   = absint( $_POST['width'] );
                $success = update_option( '_ipsw_site_popup', $popupid );
                $success = update_option( '_ipsw_site_popup_width', $width );
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2>
                    <?php _e( 'Site Popup', 'wp_social_widget' ); ?>
                </h2>
                <?php
                if ( $submit ) {
                    echo '<div id="messages" class="updated"><p>' . __( 'Successfully set Pop Up for your site' ) . '</p></div>';
                }
                ?>
                <div id="popupOptions">
                    <form action="" method="post">
                        <table class="form-table">
                            <tbody>
                                <tr valign="top">
                                    <th scope="row">
                                        <label for="ipsw_inputWidget"><?php _e( 'Widget' ); ?></label>
                                    </th>
                                    <td>
                                        <?php
                                        $args = array(
                                            'orderby'     => 'post_date',
                                            'order'       => 'DESC', 
                                            'post_type'   => 'ipsocialwidget',
                                            'post_status' => array(
                                                'timeline',
                                                'author',
                                                'email',
                                                'sales',
                                                'contact',
                                                'profile',
                                                'link',
                                            ),
                                            'posts_per_page' => -1,
                                            'paged'          => $page
                                        );
                                        $query   = new WP_Query;
                                        $widgets = $query->query( $args );
                                        ?>
                                        <select name="widget" id="ipsw_inputWidget">
                                            <option value="0"><?php _e( 'Do not use popup' ); ?></option>
                                            <?php
                                            $widget_id = get_option( '_ipsw_site_popup', 0 );
                                            foreach( $widgets as $widget ) {
                                                
                                                $status = $widget->post_status;
                                                if ( $status == 'timeline' ) {
                                                    $type = __( 'Social Timeline' );
                                                } elseif ( $status == 'author' ) {
                                                    $type = __( 'Author' );
                                                } elseif ( $status == 'email' ) {
                                                    $type = __( 'Email Block' );
                                                } elseif ( $status == 'sales' ) {
                                                    $type = __( 'Sales Block' );
                                                } elseif ( $status == 'contact' ) {
                                                    $type = __( 'Contact Detail' );
                                                } elseif ( $status == 'profile' ) {
                                                    $type = __( 'Social Profile' );
                                                } elseif ( $status == 'link' ) {
                                                    $type = __( 'Social Link' );
                                                }
                                                $selected = '';
                                                if ( $widget_id == $widget->ID ) {
                                                    $selected = ' selected="selected"';
                                                }
                                                echo '<option' . $selected . ' value="' . $widget->ID .  '">' . $widget->post_title . ' (' . $type . ')</option>';
                                            }
                                            ?>
                                        </select>
                                    </td>
                                </tr>
                                <tr valign="top">
                                    <th scope="row">
                                        <label for="ipsw_inputWidget"><?php _e( 'Width' ); ?></label>
                                    </th>
                                    <td>
                                        <?php
                                        $width = get_option( '_ipsw_site_popup_width', 500 );
                                        ?>
                                        <input type="text" class="input-small" id="ipsw_inputWidth" name="width" value="<?php echo $width; ?>" /> px
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <div class="buttons">
                            <input type="submit" class="button button-primary button-large" id="ipsw_set_popup" name="ipsw_set_popup" value="Save" />
                        </div>
                    </form>
                </div>
                
            </div>
        <?php
        }
        
        /**
         * Show content admin add new
         *
         * @return void
         */
        public function add()
        {
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2>
                    Add Widget
                </h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div class="ipsw-add-link">
                        <ul class="clearfix">
                            <li class="ipsw-add-timeline">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=timeline">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Social Timeline Widget</strong>
                                        <em>Create the very cool "timeline" social widget</em>
                                    </span>
                                </a>
                            </li>
                            <li class="ipsw-add-author">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=author">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Author Widget</strong>
                                        <em>Create widget that provide a author information</em>
                                    </span>
                                </a>
                            </li>
                            <li class="ipsw-add-email">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=email">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Email Block Widget</strong>
                                        <em>Add a quick email block widget</em>
                                    </span>
                                </a>
                            </li>
                            <li class="ipsw-add-sales">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=sales">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Sales Block Widget</strong>
                                        <em>Create widget that display any type of product</em>
                                    </span>
                                </a>
                            </li>
                            <li class="ipsw-add-contact">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=contact">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Contact Detail Widget</strong>
                                        <em>Create widget that display your detail contact</em>
                                    </span>
                                </a>
                            </li>
                            <li class="ipsw-add-profile">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=profile">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Social Profile Widget</strong>
                                        <em>Create widget that display your profile</em>
                                    </span>
                                </a>
                            </li>
                            <li class="ipsw-add-soclink">
                                <a class="clearfix" href="admin.php?page=wp-socwidget-add&type=link">
                                    <i></i>
                                    <span class="ipsw-button-text">
                                        <strong>Social Link Widget</strong>
                                        <em>Create links of your social site</em>
                                    </span>
                                </a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add
         *
         * @return void
         */
        public function addType()
        {
            wp_enqueue_script('wp-color-picker');
            wp_enqueue_style('wp-color-picker');
            
            $type = $_GET['type'];
            switch ( $type )
            {
                case 'timeline' :
                    $this->editTimeline();
                    break;
                    
                case 'author':
                    $this->editAuthor();
                    break;
                    
                case 'email':
                    $this->editEmail();
                    break;
                    
                case 'sales':
                    $this->editSales();
                    break;
                    
                case 'contact':
                    $this->editContact();
                    break;
                    
                case 'profile':
                    $this->editProfile();
                    break;
                    
                case 'link':
                    $this->editLink();
                    break;
                    
                default :
                    exit();
            }
        }
        
        /**
         * Show content admin edit
         *
         * @return void
         */
        public function edit()
        {
            if ( empty( $_GET['widget_id'] )) {
                wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?') );
            }
            $widgetId = absint( $_GET['widget_id'] );
            if ( ! $widget = get_post( $widgetId ) ) {
                wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?') );
            }
            
            wp_enqueue_script('wp-color-picker');
            wp_enqueue_style('wp-color-picker');
            
            $type = $widget->post_status;
            switch ( $type )
            {
                case 'timeline' :
                    $this->editTimeline( $widget );
                    break;
                    
                case 'author':
                    $this->editAuthor( $widget );
                    break;
                    
                case 'email':
                    $this->editEmail( $widget );
                    break;
                    
                case 'sales':
                    $this->editSales( $widget );
                    break;
                    
                case 'contact':
                    $this->editContact( $widget );
                    break;
                    
                case 'profile':
                    $this->editProfile( $widget );
                    break;
                    
                case 'link':
                    $this->editLink( $widget );
                    break;
                    
                default :
                    exit();
            }
        }
        
        /**
         * Show content admin add/edit timeline
         *
         * @param  object $widget
         * @return void
         */
        public function editTimeline( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Social Timeline Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->timelinePreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="timeline" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'timeline', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldTitle( $widget, $setting );
                            $this->fieldDescription( $widget, $setting );
                            $this->fieldBgImage( $widget, $setting );
                            $this->fieldPhoto( $widget, $setting );
                            $this->fieldFooterText( $widget, $setting );
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add/edit author widget
         *
         * @param  object $widget
         * @return void
         */
        public function editAuthor( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Author Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->authorPreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="author" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'author', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldTitle( $widget, $setting );
                            $this->fieldDescription( $widget, $setting );
                            $this->fieldBgImage( $widget, $setting );
                            $this->fieldPhoto( $widget, $setting );
                            $this->fieldFooterText( $widget, $setting );
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add/edit email widget
         *
         * @param  object $widget
         * @return void
         */
        public function editEmail( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Email Block Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->emailPreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="email" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'email', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldTitle( $widget, $setting );
                            $this->fieldDescription( $widget, $setting );
                            
                            $email = '';
                            if ( $setting ) {
                                $email = $setting->getSetting( 'email', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-email"><?php _e( 'Email Address' ); ?></label>
                                <input type="text" size="40" value="<?php echo $email; ?>" id="input-email" name="email">
                            </div>
                            
                            <?php
                            $label = '';
                            $color = '#000000';
                            if ( $setting ) {
                                $label = $setting->getSetting( 'label', '' );
                                $color = $setting->getSetting( 'label_color', '#000000' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-label"><?php _e( 'Link Label' ); ?></label>
                                <input type="text" size="40" value="<?php echo $label; ?>" id="input-label" name="label">
                                <div class="input-color">
                                    <span class="lbl">Label color:</span> <input type="text" class="color-picker" name="label_color" id="input-label-color" value="<?php echo $color; ?>" />
                                </div>
                            </div>
                            
                            <?php
                            $this->fieldPhoto( $widget, $setting );
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add/edit sales block widget
         *
         * @param  object $widget
         * @return void
         */
        public function editSales( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Sales Block Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->salesPreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="sales" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'sales', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldTitle( $widget, $setting );
                            $this->fieldDescription( $widget, $setting );
                            
                            $price = '';
                            if ( $setting ) {
                                $price = $setting->getSetting( 'price', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-price"><?php _e( 'Price' ); ?></label>
                                <input type="text" size="40" value="<?php echo $price; ?>" id="input-price" name="price">
                            </div>
                            
                            <?php
                            $label = '';
                            if ( $setting ) {
                                $label = $setting->getSetting( 'label', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-label"><?php _e( 'Button Label' ); ?></label>
                                <input type="text" size="40" value="<?php echo $label; ?>" id="input-label" name="label">
                            </div>
                            
                            <?php
                            $url = '';
                            if ( $setting ) {
                                $url = $setting->getSetting( 'url', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-url"><?php _e( 'Button Url' ); ?></label>
                                <input type="text" size="40" value="<?php echo $url; ?>" id="input-url" name="url">
                            </div>
                            
                            <?php
                            $this->fieldFooterText( $widget, $setting );
                            $this->fieldProductImage( $widget, $setting );
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add/edit profile widget
         *
         * @param  object $widget
         * @return void
         */
        public function editProfile( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Social Profile Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->profilePreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="profile" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'profile', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldTitle( $widget, $setting );
                            $this->fieldDescription( $widget, $setting );
                            
                            $permalink = '';
                            if ( $setting ) {
                                $permalink = $setting->getSetting( 'permalink', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-permalink"><?php _e( 'Profile Url' ); ?></label>
                                <input type="text" size="40" value="<?php echo $permalink; ?>" id="input-permalink" name="permalink">
                            </div>
                            
                            <?php
                            $label = '';
                            $color = '#000000';
                            if ( $setting ) {
                                $label = $setting->getSetting( 'label', '' );
                                $color = $setting->getSetting( 'label_color', '#000000' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-label"><?php _e( 'Link Profile Label' ); ?></label>
                                <input type="text" size="40" value="<?php echo $label; ?>" id="input-label" name="label">
                                <div class="input-color">
                                    <span class="lbl">Label color:</span> <input type="text" class="color-picker" name="label_color" id="input-label-color" value="<?php echo $color; ?>" />
                                </div>
                            </div>
                            
                            <?php
                            $this->fieldBgImage( $widget, $setting );
                            $this->fieldPhoto( $widget, $setting );
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add/edit contact widget
         *
         * @param  object $widget
         * @return void
         */
        public function editContact( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Contact Detail Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->contactPreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="contact" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'contact', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldPhoto( $widget, $setting );
                            
                            $name = '';
                            $color = '#000000';
                            if ( $setting ) {
                                $name  = $setting->getSetting( 'name', '' );
                                $color = $setting->getSetting( 'name_color', '#000000' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-name"><?php _e( 'Company Name' ); ?></label>
                                <input type="text" size="40" value="<?php echo $name; ?>" id="input-name" name="name">
                                <div class="input-color">
                                    <span class="lbl">Name color:</span> <input type="text" class="color-picker" name="name_color" id="input-name-color" value="<?php echo $color; ?>" />
                                </div>
                            </div>
                            
                            <?php
                            $address = '';
                            if ( $setting ) {
                                $address = $setting->getSetting( 'address', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-address"><?php _e( 'Address' ); ?></label>
                                <textarea id="input-address" name="address"><?php echo $address; ?></textarea>
                            </div>
                            
                            <?php
                            $email = '';
                            if ( $setting ) {
                                $email = $setting->getSetting( 'email', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-email"><?php _e( 'Email Address' ); ?></label>
                                <input type="text" size="40" value="<?php echo $email; ?>" id="input-email" name="email">
                            </div>
                            
                            <?php
                            $phone = '';
                            if ( $setting ) {
                                $phone = $setting->getSetting( 'phone', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-phone"><?php _e( 'Phone Number' ); ?></label>
                                <input type="text" size="40" value="<?php echo $phone; ?>" id="input-phone" name="phone">
                            </div>
                            
                            <?php
                            $mobile = '';
                            if ( $setting ) {
                                $mobile = $setting->getSetting( 'mobile', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-mobile"><?php _e( 'Mobile' ); ?></label>
                                <input type="text" size="40" value="<?php echo $mobile; ?>" id="input-mobile" name="mobile">
                            </div>
                            
                            <?php
                            $fax = '';
                            if ( $setting ) {
                                $fax = $setting->getSetting( 'fax', '' );
                            }
                            ?>
                            <div class="form-field">
                                <label for="input-fax"><?php _e( 'Fax' ); ?></label>
                                <input type="text" size="40" value="<?php echo $fax; ?>" id="input-fax" name="fax">
                            </div>
                            
                            <?php
                            $color = '#000000';
                            if ( $setting ) {
                                $color = $setting->getSetting( 'color', '' );
                            }
                            ?>
                            <div class="form-field">
                                <div class="input-color">
                                    <strong class="lbl">Contact detail color:</strong> <input type="text" class="color-picker" name="color" id="input-text-color" value="<?php echo $color; ?>" />
                                </div>
                            </div>
                            
                            <?php
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content admin add/edit link widget
         *
         * @param  object $widget
         * @return void
         */
        public function editLink( $widget = false )
        {
            $setting  = false;
            $widgetId = 0;
            if ( $widget ) {
                $setting  = new IPSocialWidget_Setting( $widget->ID );
                $widgetId = $widget->ID;
            }
        ?>
            <div class="wrap">
                <div id="icon-page-ipsocwidget" class="icon32">
                    <br>
                </div>
                <h2><?php _e( 'Link Widget' ); ?></h2>
                <div id="ip_messages"></div>
                
                <div class="ipsw-main">
                    <div id="col-container">
                        <div id="col-right">
                            <div class="col-wrap">
                            
                                <div class="widget-preview">
                                    <h3><?php _e( 'Preview' ); ?></h3>
                                    <div id="ipsw-preview-content">
                                        <?php
                                        if ( $widget ) {
                                            $factory = new IPSocialWidget_Factory( $widget->ID );
                                            echo $factory->linkPreview();
                                        }
                                        ?>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                        <div id="col-left">
                            <div class="col-wrap">
                    
                    <div class="form-wrap">
                        <h3><?php _e( 'Add Widget' ); ?></h3>
                        <form id="editwidget" class="validate ipsw-form" action="" method="post">
                            <input type="hidden" id="ipsw_widgetId" name="socwidget_id" value="<?php echo $widgetId; ?>" />
                            <input type="hidden" id="ipsw_widgetType" name="widget_type" value="link" />
                            <?php
                            $this->fieldWidgetName( $widget, $setting );
                            $this->fieldWidgetStyle( 'link', $widget, $setting );
                            $this->fieldFont( $widget, $setting );
                            $this->fieldTitle( $widget, $setting );
                            $this->fieldSocialLinks( $widget, $setting );
                            $this->buttons();
                            ?>
                        </form>
                    </div>
        
                    <script type="text/javascript">
                        jQuery(document).ready(function() {
                            //Color picker
                            jQuery('.color-picker').wpColorPicker();
                        });
                    </script>
                    
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Element widget name
         */
        public function fieldWidgetName( $widget = false, $setting = false )
        {
            $name = '';
            if ( $widget ) {
                $name = $widget->post_title;
            }
        ?>
            <div class="form-field form-required">
                <label for="widget-name">
                    <?php _e( 'Widget Name' ); ?> 
                </label>
                <input type="text" aria-required="true" size="40" value="<?php echo $name; ?>" id="widget-name" name="widget_name">
            </div>
        <?php
        }
        
        /**
         * Element widget style
         */
        public function fieldWidgetStyle( $type, $widget = false, $setting = false )
        {
            $plgurl = plugin_dir_url( dirname(__FILE__) );
            $prvurl = $plgurl . 'img/preview/';
            $styles = array(
                'style1' => 'Style 1',
                'style2' => 'Style 2',
                'style3' => 'Style 3',
            );
            $selectedLabel = 'Style 1';
            $selectedValue = 'style1';
            if ( $setting ) {
                $style = $setting->getSetting( 'style' );
                $selectedValue = $style;
                if ( ! empty( $styles[$style] )) {
                    $selectedLabel = $styles[$style];
                } else {
                    $selectedLabel = 'Unknown';
                }
            }
        ?>
            <div id="field-style" class="form-field form-required">
                <label for="widget-style">
                    <?php _e( 'Widget Style' ); ?> 
                </label>
                <div class="ipsw-menu ipsw-gen-menu ipsw-style-menu">
                    <div class="ipsw-selected">
                        <div class="ipsw-selected-box">
                            <?php echo $selectedLabel; ?>
                        </div>
                        <span class="toggle"></span>
                    </div>
                    <div class="ipsw-select" style="display: none;">
                        <div class="ipsw-select-content">
                            <ul class="clearfix">
                                <?php
                                foreach( $styles as $id => $label ) :
                                    $src = $prvurl . $type . '-' . $id . '.jpg';
                                ?>
                                    <li data-select="<?php echo $id; ?>">
                                        <strong class="ipsw-select-label"><?php echo $label; ?></strong>
                                        <img src="<?php echo $src; ?>" alt="<?php echo $label; ?>">
                                    </li>
                                <?php
                                endforeach;
                                ?>
                            </ul>
                        </div>
                    </div>
                    <input type="hidden" name="ipsw_style" class="ipsw-input-select" id="ipsw-input-style" value="<?php echo $selectedValue; ?>" />
                </div>
            </div>
        <?php
        }
        
        /**
         * Option font
         */
        public function fieldFont( $widget = false, $setting = false )
        {
            $fonts = array(
                'Arial'             => 'Arial',
                'Arial_Black'       => 'Arial Black',
                'Cooper_Black'      => 'Cooper Black',
                'Garamond'          => 'Garamond',
                'Georgia'           => 'Georgia',
                'Impact'            => 'Impact',
                'Tahoma'            => 'Tahoma',
                'Times_New_Roman'   => 'Times New Roman',
                'Trebuchet_MS'      => 'Trebuchet MS',
                'Verdana'           => 'Verdana',
            );
            $selectedLabel = 'Arial';
            $selectedValue = 'Arial';
            if ( $setting ) {
                $font = $setting->getSetting( 'font_family' );
                $selectedValue = $font;
                if ( ! empty( $fonts[$font] )) {
                    $selectedLabel = $fonts[$font];
                } else {
                    $selectedLabel = 'Unknown';
                }
            }
        ?>
            <div id="font-options" class="form-field">
                <label for="input-font"><?php _e( 'Font' ); ?></label>
                <div class="ipsw-menu ipsw-gen-menu ipsw-font-menu">
                    <div class="ipsw-selected">
                        <div class="ipsw-selected-box">
                            <?php echo $selectedLabel; ?>
                        </div>
                        <span class="toggle"></span>
                    </div>
                    <div class="ipsw-select" style="display: none;">
                        <div class="ipsw-select-content">
                            <ul class="clearfix">
                                <?php
                                foreach( $fonts as $id => $label ) :
                                ?>
                                    <li data-select="<?php echo $id; ?>">
                                        <strong class="ipsw-select-label"><?php echo $label; ?></strong>
                                    </li>
                                <?php
                                endforeach;
                                ?>
                            </ul>
                        </div>
                    </div>
                    <input type="hidden" name="ipsw_ffamily" class="ipsw-input-select" id="ipsw-input-ffamily" value="<?php echo $selectedValue; ?>" />
                </div>
            </div>
        <?php
        }
        
        /**
         * Input title
         */
        public function fieldTitle( $widget = false, $setting = false )
        {
            $title = '';
            $color = '#000000';
            if ( $setting ) {
                $title = $setting->getSetting( 'title', '' );
                $color = $setting->getSetting( 'title_color', '#000000' );
            }
        ?>
            <div class="form-field">
                <label for="input-title"><?php _e( 'Title' ); ?></label>
                <input type="text" size="40" value="<?php echo $title; ?>" id="input-title" name="title">
                <div class="input-color">
                    <span class="lbl">Title color:</span> <input type="text" class="color-picker" name="title_color" id="input-title-color" value="<?php echo $color; ?>" />
                </div>
            </div>
        <?php
        }
        
        /**
         * Input description
         */
        public function fieldDescription( $widget = false, $setting = false )
        {
            $desc  = '';
            $color = '#000000';
            if ( $setting ) {
                $desc  = $setting->getSetting( 'description', '' );
                $color = $setting->getSetting( 'description_color', '#000000' );
            }
        ?>
            <div class="form-field">
                <label for="input-description"><?php _e( 'Description' ); ?></label>
                <textarea id="input-desription" name="description"><?php echo $desc; ?></textarea>
                <div class="input-color">
                    <span class="lbl">Description color:</span> <input type="text" class="color-picker" name="description_color" id="input-desc-color" value="<?php echo $color; ?>" />
                </div>
            </div>
        <?php
        }
        
        /**
         * Input background image
         */
        public function fieldBgImage( $widget = false, $setting = false )
        {
        ?>
            <div id="field-bgimage" class="form-field field-upload">
            
                <input type="hidden" name="upload_type" class="ipsw-upload-type" value="background_image" />
                <label for="input-bgimage"><?php _e( 'Background Image' ); ?></label>
                <div class="input-image">
                    <div class="image-preview">
                        <?php
                        $setImg = false;
                        if ( $setting ) {
                            if ( $attachId = $setting->getSetting( 'background_image' ) ) {
                                $setImg = true;
                                $data   = wp_get_attachment_image_src( $attachId, 'thumbnail' );
                            }
                        }
                        if ( $setImg ) {
                            echo '<div class="popupImg"><img src="' . $data[0] . '" /></div>';
                        } else {
                            echo '<div class="none">No image</div>';
                        }
                        ?>
                    </div>
                    <div class="image-upload">
                        <h5><?php _e( 'Upload Image' ); ?></h5>
                        <input id="input-bgimage" class="uploadInput" type="file" name="import" />
                        <input class="button ipswBtnUpload" type="submit" id="uploadBgImage" name="uploadImage" value="<?php _e( 'Upload' ); ?>" />
                        <?php
                        if ( ! $setImg ) {
                            $display  = ' style="display:none;"';
                            $attachId = 0;
                        } else {
                            $display = '';
                        }
                        ?>
                        <div class="ipsw_resetImage"<?php echo $display; ?>>
                            <h5><?php _e( 'Clear Background Image' ); ?></h5>
                            <a class="ipsw_doResetImage button" href=""><?php _e( 'Clear Image' ); ?></a>
                        </div>
                        <input type="hidden" name="bgimageid" class="ipsw_bgImageId" value="<?php echo $attachId; ?>" />
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Input photo
         */
        public function fieldPhoto( $widget = false, $setting = false )
        {
        ?>
            <div id="field-photo" class="form-field field-upload">
               
                <input type="hidden" name="upload_type" class="ipsw-upload-type" value="photo_profile" />
                <label for="input-photo"><?php _e( 'Photo Profile' ); ?></label>
                <div class="input-image">
                    <div class="image-preview">
                        <?php
                        $setImg = false;
                        if ( $setting ) {
                            if ( $attachId = $setting->getSetting( 'photo_profile' ) ) {
                                $setImg = true;
                                $data   = wp_get_attachment_image_src( $attachId, 'thumbnail' );
                            }
                        }
                        if ( $setImg ) {
                            echo '<div class="popupImg"><img src="' . $data[0] . '" /></div>';
                        } else {
                            echo '<div class="none">No image</div>';
                        }
                        ?>
                    </div>
                    <div class="image-upload">
                        <h5><?php _e( 'Upload Image' ); ?></h5>
                        <input id="input-photo" class="uploadInput" type="file" name="import" />
                        <input class="button ipswBtnUpload" type="submit" id="uploadPhoto" name="uploadImage" value="<?php _e( 'Upload' ); ?>" />
                        <?php
                        if ( ! $setImg ) {
                            $display  = ' style="display:none;"';
                            $attachId = 0;
                        } else {
                            $display = '';
                        }
                        ?>
                        <div class="ipsw_resetImage"<?php echo $display; ?>>
                            <h5><?php _e( 'Clear Photo Profile' ); ?></h5>
                            <a class="ipsw_doResetImage button" href=""><?php _e( 'Clear Photo' ); ?></a>
                        </div>
                        <input type="hidden" name="photoid" class="ipsw_bgImageId" value="<?php echo $attachId; ?>" />
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Input product image
         */
        public function fieldProductImage( $widget = false, $setting = false )
        {
        ?>
            <div id="field-image" class="form-field field-upload">
               
                <input type="hidden" name="upload_type" class="ipsw-upload-type" value="product_image" />
                <label for="input-prod-image"><?php _e( 'Product Image' ); ?></label>
                <div class="input-image">
                    <div class="image-preview">
                        <?php
                        $setImg = false;
                        if ( $setting ) {
                            if ( $attachId = $setting->getSetting( 'product_image' ) ) {
                                $setImg = true;
                                $data   = wp_get_attachment_image_src( $attachId, 'thumbnail' );
                            }
                        }
                        if ( $setImg ) {
                            echo '<div class="popupImg"><img src="' . $data[0] . '" /></div>';
                        } else {
                            echo '<div class="none">No image</div>';
                        }
                        ?>
                    </div>
                    <div class="image-upload">
                        <h5><?php _e( 'Upload Image' ); ?></h5>
                        <input id="input-photo" class="uploadInput" type="file" name="import" />
                        <input class="button ipswBtnUpload" type="submit" id="uploadPhoto" name="uploadImage" value="<?php _e( 'Upload' ); ?>" />
                        <?php
                        if ( ! $setImg ) {
                            $display  = ' style="display:none;"';
                            $attachId = 0;
                        } else {
                            $display = '';
                        }
                        ?>
                        <div class="ipsw_resetImage"<?php echo $display; ?>>
                            <h5><?php _e( 'Clear Product Image' ); ?></h5>
                            <a class="ipsw_doResetImage button" href=""><?php _e( 'Clear Image' ); ?></a>
                        </div>
                        <input type="hidden" name="imageid" class="ipsw_bgImageId" value="<?php echo $attachId; ?>" />
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Input footer text
         */
        public function fieldFooterText( $widget = false, $setting = false )
        {
            $footer = '';
            $color  = '#000000';
            if ( $setting ) {
                $footer = $setting->getSetting( 'footer_text', '' );
                $color  = $setting->getSetting( 'footer_text_color', '#000000' );
            }
        ?>
            <div class="form-field">
                <label for="input-footer"><?php _e( 'Footer Text' ); ?></label>
                <input type="text" size="40" value="<?php echo $footer; ?>" id="input-footer" name="footer_text">
                <div class="input-color">
                    <span class="lbl">Footer Text color:</span> <input type="text" class="color-picker" name="footer_text_color" id="input-footer-color" value="<?php echo $color; ?>" />
                </div>
            </div>
        <?php
        }
        
        /**
         * Input social links
         */
        public function fieldSocialLinks( $widget = false, $setting = false )
        {
        ?>
            <div class="form-field">
                <label for="input-social"><?php _e( 'Social Links' ); ?></label>
                <div class="input-social-links">
                    <table>
                        <?php
                        $links = false;
                        if ( $setting ) {
                            $links = $setting->getSetting( 'social_links' );
                        }
                        if ( $links ) :
                            foreach( $links as $link ) :
                        ?>
                        <tr>
                            <?php 
                            $this->_getSocialTypeOpt( $link['type'], 'social_type[]' ); 
                            $this->_getSocialIconOpt( $link['icon'], $link['type'], 'social_icon[]' ); 
                            ?>
                            <td class="social-link-label">
                                <?php echo $this->_getSocialHost( $link['type'] ); ?>
                            </td>
                            <td class="social-link">
                                <input type="text" name="social_link[]" value=" <?php echo $link['url']; ?>" />
                            </td>
                            <td class="social-delete">
                                <a href="">Delete</a>
                            </td>
                        </tr>
                        <?php
                            endforeach;
                        else :
                        ?>
                        <tr>
                            <?php 
                            $this->_getSocialTypeOpt( 'facebook', 'social_type[]' ); 
                            $this->_getSocialIconOpt( 'style1', 'facebook', 'social_icon[]' ); 
                            ?>
                            <td class="social-link-label">
                                http://facebook.com/
                            </td>
                            <td class="social-link">
                                <input type="text" name="social_link[]" value="" />
                            </td>
                            <td class="social-delete">
                                <a href="">Delete</a>
                            </td>
                        </tr>
                        <?php
                        endif;
                        ?>
                    
                        <tr id="_social_icon_sample" style="display:none;">
                            <?php 
                            $this->_getSocialTypeOpt( 'facebook', '_social_type' ); 
                            $this->_getSocialIconOpt( 'style1', 'facebook', '_social_icon' ); 
                            ?>
                            <td class="social-link-label">
                                http://facebook.com/
                            </td>
                            <td class="social-link">
                                <input type="text" name="_social_link" value="" />
                            </td>
                            <td class="social-delete">
                                <a href="">Delete</a>
                            </td>
                        </tr>
                        
                    </table>
                    <a href="#" id="add-social-link" class="button">Add Link</a>
                </div>
            </div>
        <?php
        }
        
        /**
         * Get social type options
         **/
        protected function _getSocialTypeOpt( $selected, $name )
        {
            $socials = array(
                'dribbble'      => 'Dribbble',
                'facebook'      => 'Facebook',
                'flickr'        => 'Flickr',
                'github'        => 'Github',
                'gplus'         => 'Google++',
                'instagram'     => 'Instagram',
                'linkedin'      => 'LinkedIn',
                'pinterest'     => 'Pinterest',
                'tumblr'        => 'Tumblr',
                'twitter'       => 'Twitter',
                'vimeo'         => 'Vimeo',
                'youtube'       => 'Youtube',
            );
        ?>
            <td class="social-type">
                <div class="ipsw-menu ipsw-gen-menu">
                    <div class="ipsw-selected">
                        <div class="ipsw-selected-box">
                            <?php echo $socials[$selected]; ?>
                        </div>
                        <span class="toggle"></span>
                    </div>
                    <div class="ipsw-select" style="display: none;">
                        <div class="ipsw-select-content">
                            <ul class="clearfix">
                                <?php
                                foreach( $socials as $id => $label ) :
                                ?>
                                    <li data-select="<?php echo $id; ?>">
                                        <strong class="ipsw-select-label"><?php echo $label; ?></strong>
                                    </li>
                                <?php
                                endforeach;
                                ?>
                            </ul>
                        </div>
                    </div>
                    <input type="hidden" name="<?php echo $name; ?>" class="ipsw-input-select" value="<?php echo $selected; ?>" />
                </div>
            </td>
        <?php
        }
        
        /**
         * Get social icon options
         **/
        protected function _getSocialIconOpt( $selected, $type, $name )
        {
            $icons = array(
                'style1' => 'Style 1',
                'style2' => 'Style 2',
                'style3' => 'Style 3',
                'style4' => 'Style 4',
                'style5' => 'Style 5',
                'style6' => 'Style 6',
                'style7' => 'Style 7',
            );
            $plgurl = plugin_dir_url( dirname(__FILE__) );
            $imgurl = $plgurl . 'img/social/';
            $file   = $type . '.png';
            $label  = $icons[$selected];
        ?>
            <td class="social-icon">
                <div class="ipsw-menu ipsw-gen-menu">
                    <div class="ipsw-selected">
                        <div class="ipsw-selected-box">
                            <img src="<?php echo $imgurl . $selected . '/' . $file; ?>" alt="<?php $label; ?>" />
                        </div>
                        <span class="toggle"></span>
                    </div>
                    <div class="ipsw-select" style="display: none;">
                        <div class="ipsw-select-content">
                            <ul class="clearfix">
                                <?php 
                                foreach( $icons as $id => $label ) :
                                ?>
                                    <li data-select="<?php echo $id; ?>">
                                        <strong class="ipsw-select-label">
                                            <img src="<?php echo $imgurl . $id . '/' . $file; ?>" alt="<?php echo $label; ?>" />
                                        </strong>
                                    </li>
                                <?php
                                endforeach;
                                ?>
                            </ul>
                        </div>
                    </div>
                    <input type="hidden" name="<?php echo $name; ?>" class="ipsw-input-select" value="<?php echo $selected; ?>" />
                </div>
            </td>
        <?php
        }
        
        /**
         * Get social host
         *
         * @return string
         */
        protected function _getSocialHost( $type )
        {
            $host = 'http://';
            if ( $type == 'facebook' ) {
                $host .= 'facebook.com/';
            } elseif ( $type == 'twitter' ) {
                $host .= 'twitter.com/';
            } elseif ( $type == 'linkedin' ) {
                $host .= 'linkedin.com/in/';
            } elseif ( $type == 'pinterest' ) {
                $host .= 'pinterest.com/';
            } elseif ( $type == 'gplus' ) {
                $host .= 'plus.google.com/';
            } elseif ( $type == 'tumblr' ) {
                $host .= '';
            } elseif ( $type == 'youtube' ) {
                $host .= 'youtube.com/user/';
            } elseif ( $type == 'vimeo' ) {
                $host .= 'vimeo.com/';
            } elseif ( $type == 'dribbble' ) {
                $host .= 'dribbble.com/';
            } elseif ( $type == 'instagram' ) {
                $host .= 'instagram.com/';
            } elseif ( $type == 'github' ) {
                $host .= 'github.com/';
            } elseif ( $type == 'flickr' ) {
                $host .= 'flickr.com/photos/';
            }
            return $host;
        }
        
        /**
         * Buttons form 
         **/
        public function buttons()
        {
        ?>
            <div class="buttons">
                <input type="submit" class="button button-primary button-large ipsw-save-button" name="isc_save_timeline" value="<?php _e( 'Save' ); ?>" />
                
                <input type="submit" class="button button-large ipsw-finish-button" name="isc_finish_timeline" value="<?php _e( 'Finish' ); ?>" />
            </div>
        <?php
        }
    }
}
?>