/**
 * Menu control
 **/
(function($){
   
   //Fancy option
    $.fn.ipsw_fancyoption = function(options){
    
        //Setup
        $( '.ipsw-select li:first-child' ).addClass( 'ipsw-item-selected' );
        
        $(this).each( function(){
        
            var option  = $(this);
            var in_menu = false;
            
            $( '.ipsw-selected', option ).click( function(){
                
                var menu   = $(this);
                var select = $( '.ipsw-select', option );
                
                if ( select.is(":visible") ) {
                    select.fadeOut( "fast" );
                    menu.removeClass( 'active' );
                } else {
                    
                    $( '.ipsw-select' ).each( function(){
                        $(this).fadeOut( "fast" );
                        $(this).parents( '.ipsw-selected' ).removeClass( 'active' );
                    });
                    select.fadeIn( "fast" );
                    menu.addClass( 'active' );
                }
                return false;
            });
            $( '.ipsw-select', option ).hover( function(){
                    in_menu = true;
                }, function(){
                    in_menu = false;
            });
            $( "body" ).click(function(){
                if ( ! in_menu ) {
                    $( '.ipsw-select', option ).fadeOut( "fast" );
                    $( '.ipsw-selected', option ).removeClass( 'active' );
                }
            });
            
            $( 'li', option ).click( function(){
            
                var item  = $(this);
                var label = $( '.ipsw-select-label', item ).clone().html();
                var data  = item.data( 'select' );
                $( '.ipsw-selected .ipsw-selected-box', option ).html( label );
                $( '.ipsw-select li', option ).removeClass( 'ipsw-item-selected' );
                item.parents( 'li' ).addClass( 'ipsw-item-selected' );
                $( '.ipsw-input-select', option ).val( data );
                
                //Hide Select box
                $( '.ipsw-select', option ).fadeOut( "fast" );
                $( '.ipsw-selected', option ).removeClass( 'active' );
            });
        
        });
    
    };
    
    $.fn.ipswUploadImage = function(setting){
    
        $(this).each( function(){
        
            var root  = $(this),
                files = 'null',
                formdata = false;
            
            if (window.FormData) {
                formdata = new FormData();
            }
            if ( files == 'null' ) {
                $( '.ipswBtnUpload', root ).addClass( 'button-disabled' );
                $( '.ipswBtnUpload', root ).attr( 'disabled', 'disabled' );
            }
            
            $( '.uploadInput', root ).change( function(){
                $( '.ipswBtnUpload', root ).removeClass( 'button-disabled' );
                $( '.ipswBtnUpload', root ).removeAttr( 'disabled' );
                files = this.files;
            });
            
            $( '.ipswBtnUpload', root ).click( function(){
            
                var button = $(this);
                var id     = $( '#ipsw_widgetId' ).val();
                
                if ( files == 'null' ) {
                    alert( 'You must select an image' );
                } else {
                
                    var loader = '<div class="ipsw_loader_small"></div>';
                    button.after( loader );
                    button.addClass( 'button-disabled' );
                    button.attr( 'disabled', 'disabled' );
                    
                    var len = files.length;

                    for ( var i = 0; i < len; i++ ) {
                        file = files[i];
                
                        if (!!file.type.match(/image.*/)) {
                            if ( window.FileReader ) {
                                reader = new FileReader();
                                reader.readAsDataURL(file);
                            }
                            if (formdata) {
                                formdata.append("async-upload", file);
                            }
                        }
                    }
                    
                    var type  = $( '.ipsw-upload-type', root ).val();
                    var wtype = $( '#ipsw_widgetType' ).val();
                    if (formdata) {
                        $.ajax({
                            url: ajaxurl+'?doajax=1&ipsw=1&action=ipsw_upload&widget_id='+id+'&type='+type+'&widget_type='+wtype,
                            type: "POST",
                            data: formdata,
                            processData: false,
                            contentType: false,
                            dataType: "json",
                            success: function ( result ) {
                                
                                if ( result.status == '1' ) {
                                    
                                    if ( result.data.sizes.medium !== undefined ) {
                                        var src = result.data.sizes.medium.url;
                                    } else {
                                        var src = result.data.sizes.full.url;
                                    }
                                    ipsw_setInputMessage( 'Successfully uploading image', 'updated', root );
                                    $( '.image-preview', root ).html( '<img src="'+src+'">' );
                                    $( '.ipsw_bgImageId', root ).val(result.data.id);
                                    $( '.ipsw_resetImage', root ).show();
                                    
                                    if ( result.widgetid !== undefined ) {
                                        $( '#ipsw_widgetId' ).val( result.widgetid );
                                    }
                                    
                                } else {
                                    ipsw_setInputMessage( 'Upload image was failed', 'error', root );
                                }
                                button.removeClass( 'button-disabled' );
                                button.removeAttr( 'disabled', 'disabled' );
                                $( '.ipsw_loader_small' ).remove();
                            }
                        });
                    }
                }
                return false;
            });
            
            $( '.ipsw_doResetImage', root ).click( function(){
                
                var button = $(this);
                var id     = $( '#ipsw_widgetId' ).val();
                var attach = $( '.ipsw_bgImageId', root ).val();
                
                var loader = '<div class="ipsw_loader_small"></div>';
                button.after( loader );
                button.addClass( 'button-disabled' );
                button.attr( 'disabled', 'disabled' );
                
                var type = $( '.ipsw-upload-type', root ).val();
                $.ajax({
                    url: ajaxurl+'?doajax=1&ipsw=1&action=ipsw_clearImage',
                    type: "POST",
                    data: 'widget_id='+id+'&type='+type+'&attach='+attach,
                    dataType: "json",
                    success: function ( result ) {
                        
                        if ( result.status == '1' ) {
                            ipsw_setInputMessage( 'Successfully clearing image', 'updated', root );
                            $( '.image-preview', root ).html( '<div class="none">No image</div>' );
                            $( '.ipsw_bgImageId', root ).val(0);
                            $( '.ipsw_resetImage', root ).hide();
                        } else {
                            ipsw_setInputMessage( 'Image was failed to clear', 'error', root );
                        }
                        button.removeClass( 'button-disabled' );
                        button.removeAttr( 'disabled', 'disabled' );
                        $( '.ipsw_loader_small' ).remove();
                    }
                });
                return false;
            });
        });
    };
   
   //Get social icons option
    $.fn.ipsw_getIconOpt = function(){
        
        var root  = $(this);
        $( '.social-type .ipsw-select-content li', root ).click( function(){
            
            var item     = $(this);
            var tr       = item.parents( 'tr' );
            var oldvalue = $( '.social-type .ipsw-input-select', root ).val();
            var newvalue = $(this).data( 'select' );
            if ( oldvalue != newvalue ) {
                $.ajax({
                    url: ajaxurl+'?doajax=1&ipsw=1&action=ipsw_getsocialicon&name='+newvalue,
                    type: "POST",
                    processData: false,
                    contentType: false,
                    success: function ( result ) {
                        
                        $( '.social-icon', tr ).html( result );
                        $( '.social-icon', tr ).ipsw_fancyoption();
                    }
                });
                var url = 'http://';
                if ( newvalue == 'facebook' ) {
                    url += 'facebook.com/';
                } else if ( newvalue == 'twitter' ) {
                    url += 'twitter.com/';
                } else if ( newvalue == 'linkedin' ) {
                    url += 'linkedin.com/in/';
                } else if ( newvalue == 'pinterest' ) {
                    url += 'pinterest.com/';
                } else if ( newvalue == 'gplus' ) {
                    url += 'plus.google.com/';
                } else if ( newvalue == 'tumblr' ) {
                    url += '';
                } else if ( newvalue == 'youtube' ) {
                    url += 'youtube.com/user/';
                } else if ( newvalue == 'vimeo' ) {
                    url += 'vimeo.com/';
                } else if ( newvalue == 'dribbble' ) {
                    url += 'dribbble.com/';
                } else if ( newvalue == 'instagram' ) {
                    url += 'instagram.com/';
                } else if ( newvalue == 'github' ) {
                    url += 'github.com/';
                } else if ( newvalue == 'flickr' ) {
                    url += 'flickr.com/photos/';
                }
                $( '.social-link-label', tr ).html( url );
            }
        });
    };
    
    //Edit widget handler
    $( '.ipsw-save-button' ).click( function(){
    
        //Remove preview
        $( '#ipsw-preview-content' ).html( '' );
        $( '#ipsw-preview-content' ).addClass( 'loading' );
        
        //Spinner
        var opts = {
            lines: 11, // The number of lines to draw
            length: 30, // The length of each line
            width: 4, // The line thickness
            radius: 19, // The radius of the inner circle
            corners: 0.9, // Corner roundness (0..1)
            rotate: 13, // The rotation offset
            direction: 1, // 1: clockwise, -1: counterclockwise
            color: '#000', // #rgb or #rrggbb
            speed: 1.3, // Rounds per second
            trail: 70, // Afterglow percentage
            shadow: false, // Whether to render a shadow
            hwaccel: false, // Whether to use hardware acceleration
            className: 'ipsw-spinner', // The CSS class to assign to the spinner
            zIndex: 2e9, // The z-index (defaults to 2000000000)
            top: 'auto', // Top position relative to parent in px
            left: 'auto' // Left position relative to parent in px
        };
        var target  = document.getElementById('ipsw-preview-content');
        var spinner = new Spinner( opts ).spin();
        target.appendChild(spinner.el);
        
        var pos = $( "#col-container" ).position();
        $('html, body').animate({scrollTop: ( pos.top )}, 1000);
        
        var dataForm = ipsw_getdataform( $( '#editwidget' ) );
        $.ajax({
            url: ajaxurl+'?doajax=1&ipsw=1&action=ipsw_savewidget&getpreview=1',
            type: "POST",
            data: dataForm,
            dataType: "json",
            success: function ( result ) {
                if ( result.status != -1 ) {
                    $( '#ipsw-preview-content' ).removeClass( 'loading' );
                    $( '#ipsw-preview-content' ).html( result.preview );
                    $( '#ipsw_widgetId' ).val( result.id );
                }
            }
        });
            
        return false;
    });
    
    $( '.ipsw-finish-button' ).click( function(){
    
        var form     = $( '#editwidget' );
        var dataForm = ipsw_getdataform( form );
        
        //Disabled button and show loading
        $( this ).addClass( 'button-disabled' );
        $( this ).attr( 'disabled', 'disabled' );
        $( '.ipsw-save-button', form ).addClass( 'button-disabled' );
        $( '.ipsw-save-button', form ).attr( 'disabled', 'disabled' );
        $( '.buttons', form ).append( '<div class="ipsw_loader_small"></div>' );
        
        $.ajax({
            url: ajaxurl+'?doajax=1&ipsw=1&action=ipsw_savewidget',
            type: "POST",
            data: dataForm,
            dataType: "json",
            success: function ( result ) {
                if ( result.status != -1 ) {
                    window.location.href = 'admin.php?page=wp-socwidget';
                }
            }
        });
            
        return false;
    });
    
    //Font Option
    $( '.ipsw-font-menu li' ).each( function(){
        var font = $(this).data( 'select' ).replace( '_', ' ' );
        $(this).css( 'font-family', font );
    });
    
    //Add input social
    $( '#add-social-link' ).click( function(){
    
        var input = $( '#_social_icon_sample' ).clone();
        input.show();
        input.removeAttr( 'id' );
        $( '.input-social-links tbody' ).append( input );
        input.ipsw_getIconOpt();
        $( '.ipsw-menu', input ).ipsw_fancyoption();
        $( '.social-delete a', input ).ipsw_deleteSoclink();
        $( '.social-type .ipsw-input-select', input ).attr( 'name', 'social_type[]' );
        $( '.social-link input', input ).attr( 'name', 'social_link[]' );
        $( '.social-icon .ipsw-input-select', input ).attr( 'name', 'social_icon[]' );
        return false;
    });
    
    //Delete input social
    $.fn.ipsw_deleteSoclink = function(){
    
        $(this).click( function(){
            var tr = $(this).parents( 'tr' );
            tr.hide( 'blind' );
            setTimeout( function(){
                tr.remove();
            }, 600);
            
            return false;
        });
    };
    
    //Delete widget data
    $( '.ip_widgetDelete' ).each( function(){
        
        var button = $(this);
        button.click( function(){
        
            var widgetid = button.attr( 'href' ).replace( '#toDeleteWidget_', '' );
            $( '.ipsw_loader_small' ).remove();
            button.addClass( 'button-disabled' );
            button.attr( 'disabled', 'disabled' );
            var loader = '<div class="ipsw_loader_small"></div>';
            button.after( loader );
            
            $.ajax({
                url: ajaxurl,
                type: "POST",
                dataType: "json",
                data: 'doajax=1&ipsw=1&action=ipsw_delete&widget_id='+widgetid,
                success: function (result) {
                    
                    if ( result.status == '-1' ) {
                        ipsw_setMessage( 'Failed to remove the popup', 'error' );
                    } else {
                        ipsw_setMessage( 'Successfully remove the popup', 'updated' );
                        var tr = button.parents( 'tr' );
                        tr.hide( 'blind' );
                        setTimeout( function(){
                            tr.remove();
                        }, 600);
                    }
                    button.removeClass( 'button-disabled' );
                    button.removeAttr( 'disabled', 'disabled' );
                    $( '.ipsw_loader_small' ).remove();
                    
                },
                error: function () {
                    alert( "Error in Adding Popup" );
                },
            });
            
            return false;
        });
    });
    
    //Edit widget handler
    $( '.ipsw-shortcode-insert' ).click( function(){
    
        var form      = $( '#ipsw-widget-table' );
        var radio     = $('input[name=widget_id]:checked', form );
        var tr        = radio.parents( 'tr' );
        var widget_id = radio.val();
        if ( widget_id == undefined ) {
            alert( "Please select widget" );
        }
        
        var type = $( '.ipsw-type', tr ).val();
        var aed  = tinyMCE.activeEditor;
        if ( aed ) {
            var content = '[ip_social_widget type="' + type + '" id="' + widget_id + '"][/ip_social_widget]';
            aed.selection.setContent( content );
        }
        $( 'input[type="radio"]', form ).removeAttr( 'checked' );
        tb_remove();
        
        return false;
    });
    
    function ipsw_getdataform( parent ) 
    {
        var selector  = 'input[type=text]';
        selector += ', input[type=hidden]';
        selector += ', input[type=password]';
        selector += ', input[type=radio]:checked';
        selector += ', input[type=checkbox]:checked';
        selector += ', textarea';
        selector += ', select';
        
        var data = '';
        
        $( selector, parent ).each( function(){
            var name  = $(this).attr( 'name' );
            var value = encodeURIComponent( $(this).val() );
            
            if ( data != '' ) {
                data += '&';
            }
            data += name+'='+value;
        });
        return data;
    };
    
    function ipsw_setMessage( msg, type ) {
        
        $( '#ipsw_messages #message' ).remove();
        var msgHtml = '<div id="message" class="' + type + ' below-h2">'
        msgHtml += '<p>' + msg + '</p>';
        msgHtml += '</div>';
        
        $( '#ipsw_messages' ).append( msgHtml );
    }
    
    function ipsw_setInputMessage( msg, type, input ) {
    
        $( '.inputMsg' ).remove();
        var msgHtml = '<div class="inputMsg ' + type + '">'
        msgHtml += '<p>' + msg + '</p>';
        msgHtml += '</div>';
        
        $( input ).before( msgHtml );
    }
    
    //Run function
    $( '.input-social-links' ).ipsw_getIconOpt();
    $( '.social-delete a' ).ipsw_deleteSoclink();
    $( '.ipsw-menu' ).ipsw_fancyoption();
    $( '.field-upload' ).ipswUploadImage();
    
})(jQuery);